package org.ak47.android.graphics.ibnrushd;

import org.ak47.android.graphics.ibnrushd.object.IbnRushdObject;

import android.content.Context;
import android.util.Log;
import android.view.View;

public class IbnRushd
{
	public static IbnRushd instance = null;
	
	private IbnRushd() {};
	
	public static void initialize(Context context, IbnRushdUpdater updater)
	{
		Log.v(Constants.TAG, "Initializing engine");
		IbnRushdRenderer.initialize(context, updater);
		Log.v(Constants.TAG, "Done initializing engine");
	}
	
	public static synchronized IbnRushd getInstance()
	{
		if (instance == null)
		{
			instance = new IbnRushd();
		}
		return instance;
	}
	
	public static View getView()
	{
		return IbnRushdRenderer.getView();
	}
	
	/**
	 * Adds an object to be rendered<br>
	 * Only objects added here will be drawn on the screen
	 * @param object
	 * @return
	 */
	public static int add(IbnRushdObject object)
	{
		return IbnRushdRenderer.add(object);
	}
	
	public static void onResume()
	{
		IbnRushdRenderer.onResume();
	}
	
	public static void onPause()
	{
		IbnRushdRenderer.onPause();
	}
}
