package org.ak47.android.graphics.ibnrushd.mesh;

import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

import javax.microedition.khronos.opengles.GL10;
import javax.microedition.khronos.opengles.GL11;

/**
 * Represents a 3D object
 * @author m0skit0
 */
public class IbnRushdMesh
{
	private FloatBuffer mVertexBuffer = null;
    private FloatBuffer mColorBuffer = null;
    private FloatBuffer mNormalBuffer = null;
    private ShortBuffer mIndexBuffer = null;
    private int faceCount = 0;
    
    public IbnRushdMesh(FloatBuffer vertex, FloatBuffer color, FloatBuffer normal, ShortBuffer index, int faces)
    {
    	mVertexBuffer = vertex;
    	mColorBuffer = color;
    	mNormalBuffer = normal;
    	mIndexBuffer = index;
    	faceCount = faces;
    }
    
    public void draw(GL10 gl)
    {
		// TODO: DEBUG
		gl.glClearColor(0, 0.5f, 0.5f, 1.0f);
		// END DEBUG
		
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
		
		if (mColorBuffer != null)
		{
			gl.glEnableClientState(GL10.GL_COLOR_ARRAY);
		}
		
		gl.glFrontFace(GL11.GL_CCW);
		gl.glVertexPointer(3, GL11.GL_FLOAT, 0, mVertexBuffer);
		
		if (mColorBuffer != null)
		{
			gl.glColorPointer(4, GL11.GL_FLOAT, 0, mColorBuffer);
		}

		int num_indexes = faceCount * 3; // Each face has 3 vertices thus 3 indexes
		gl.glDrawElements(GL11.GL_TRIANGLES, num_indexes, GL11.GL_UNSIGNED_SHORT, mIndexBuffer);
    }
    
    public boolean isColorBuffered()
    {
    	return mColorBuffer != null;
    }
    
    public boolean isNormalBuffered()
    {
    	return mNormalBuffer != null;
    }
}
