package org.ak47.android.graphics.ibnrushd.test;

import org.ak47.android.graphics.ibnrushd.IbnRushd;
import org.ak47.android.graphics.ibnrushd.IbnRushdUpdater;
import org.ak47.android.graphics.ibnrushd.mesh.IbnRushdMesh;
import org.ak47.android.graphics.ibnrushd.mesh.IbnRushdMeshFactory;
import org.ak47.android.graphics.ibnrushd.object.IbnRushdObject;
import org.ak47.android.graphics.ibnrushd.transformation.IbnRushdRotation;
import org.ak47.android.graphics.ibnrushd.transformation.IbnRushdTranslation;
import android.app.Activity;
import android.os.Bundle;

public class IbnRushdActivity extends Activity implements IbnRushdUpdater
{
	
	public static IbnRushdActivity instance = null;
	
	private IbnRushdObject test = null;
	private IbnRushdObject test2 = null;
	
	private float angle = 0;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        
        IbnRushdActivity.instance = this;
        
        IbnRushd.initialize(this, this);
        IbnRushdMesh mesh = IbnRushdMeshFactory.parseIbnRushdMesh((getResources().getXml(R.xml.colorcube)));
        //IbnRushdMesh mesh = IbnRushdMeshFactory.parseMesh((getResources().getXml(R.xml.colorcube)));
        //IbnRushdMesh mesh = IbnRushdMeshFactory.fixedMesh();
        test = new IbnRushdObject(mesh);
        test2 = new IbnRushdObject(mesh);
        
        IbnRushdTranslation trans1 = new IbnRushdTranslation();        
        trans1.setFixed(-1, -1, -10);
        test.addTransformation(trans1);
        
        IbnRushd.add(test);
        
        IbnRushdTranslation trans2 = new IbnRushdTranslation();        
        trans2.setFixed(1, 1, -10);
        test2.addTransformation(trans2);
        
        IbnRushd.add(test2);
        
        setContentView(IbnRushd.getView());
    }
    
    @Override
    public void onResume()
    {
    	super.onResume();
    	IbnRushd.onResume();
    }
    
    @Override
    public void onPause()
    {
    	super.onPause();
    	IbnRushd.onPause();
    }
    
    @Override
    public void onUpdate()
    {
    	angle += 2;
    	
    	IbnRushdRotation rot1 = new IbnRushdRotation();        
        rot1.setFixed(angle, 0.5f, 0.5f, 0);
        test.addTransformation(rot1);
        
        IbnRushdRotation rot2 = new IbnRushdRotation();        
        rot2.setFixed(angle, -0.5f, -0.5f, 0);
        test2.addTransformation(rot2);
    }
}