package org.ak47.android.graphics.ibnrushd.transformation;

import android.opengl.Matrix;

/**
 * Applies a rotation on the object 
 * @author m0skit0
 */
public class IbnRushdRotation extends IbnRushdTransformation
{
	static
	{
		TYPE = IbnRushdTransformation.ROTATION;
	}
	
	/**
	 * Sets a fixed rotation angle<br>
	 * Any previous rotation defined here is lost
	 * @param angle Angle to rotate
	 * @param x X axis component of normal rotation vector
	 * @param y Y axis component of normal rotation vector
	 * @param z Z axis component of normal rotation vector
	 */
	public void setFixed(float angle, float x, float y, float z)
	{
		float[] thisRot = new float[16];
		Matrix.setIdentityM(thisRot, 0);
		Matrix.rotateM(thisRot, 0, angle, x, y, z);
		mTransformation = thisRot;
	}
	
	/**
	 * Adds another rotation to current one<br>
	 * Previous rotation is maintained
	 * @param angle Angle to rotate
	 * @param x X axis component of normal rotation vector
	 * @param y Y axis component of normal rotation vector
	 * @param z Z axis component of normal rotation vector
	 */
	public void setIncremental(float angle, float x, float y, float z)
	{
		Matrix.rotateM(mTransformation, 0, angle, x, y, z);
	}
}
