package org.ak47.android.graphics.ibnrushd.transformation;

import android.opengl.Matrix;

public class IbnRushdScaling extends IbnRushdTransformation
{
	static
	{
		TYPE = IbnRushdTransformation.SCALING;
	}
	
	/**
	 * Sets a fixed scaling<br>
	 * Any previous defined scaling is lost
	 * @param x
	 * @param y
	 * @param z
	 */
	public void setFixed(float x, float y, float z)
	{
		float[] thisRot = new float[16];
		Matrix.setIdentityM(thisRot, 0);
		Matrix.scaleM(thisRot, 0, x, y, z);
		mTransformation = thisRot;
	}
	
	/**
	 * Adds a scaling to this one<br>
	 * Any previously defined scaling is maintaned and this one is added
	 * @param x
	 * @param y
	 * @param z
	 */
	public void setIncremental(float x, float y, float z)
	{
		Matrix.scaleM(mTransformation, 0, x, y, z);
	}
}
